namespace o {
namespace core {

	template <typename T, size_t N> 
	inline CArray<T, N>::CArray()
	{
		memset(_Data, 0, sizeof(T) * N);
	}

	template <typename T, size_t N>
	inline CArray<T, N>::CArray(const T& Value)
	{
		for(int i = 0; i < N; ++i)
			_Data[i] = Value;
	}

	template <typename T, size_t N>
	inline CArray<T, N>::CArray(T* Data, size_t Size)
	{
		size_t MinSize = Size < N ? Size : N;

		memset(_Data + sizeof(T) * MinSize, 0, sizeof(T) * (N - MinSize));

		for(int i = 0; i < MinSize; ++i)
			_Data[i] = Data[i];
	}

	template <typename T, size_t N>
	inline T& CArray<T, N>::operator[](size_t i)
	{
		if(i >= N)
			return _Data[0]; // Error !!!
		return _Data[i];
	}

	template <typename T, size_t N>
	inline const T& CArray<T, N>::operator[](size_t i) const
	{
		if(i >= N)
			return _Data[0]; // Error !!!
		return _Data[i];		
	}

    template <typename T, size_t N>
    inline CArray<T, N>::operator T*()
    {
        return _Data;
    }

    template <typename T, size_t N>
    inline CArray<T, N>::operator const T*() const 
    {
        return _Data;
    }

}//namespace core
}//namespace o
