namespace o {
namespace core {

template <typename T, bool Array>
CSmartPtr<T, Array>::CSmartPtr() :
	_RefCounter(null),
	_Pointer(null)
{}

template <typename T, bool Array>
CSmartPtr<T, Array>::CSmartPtr(const CSmartPtr<T, Array>& SmartPtr) :
	_RefCounter(SmartPtr._RefCounter),
	_Pointer(SmartPtr._Pointer)
{
	if(_RefCounter != null)
		++(*_RefCounter);
}

template <typename T, bool Array>
CSmartPtr<T, Array>::CSmartPtr(T* Pointer) :
	_Pointer(Pointer)
{
	_RefCounter = new_object(int)(1);
}

template <typename T, bool Array>
CSmartPtr<T, Array>::~CSmartPtr()
{
	_Release();
}

template <typename T, bool Array>
CSmartPtr<T, Array>& CSmartPtr<T, Array>::operator=(const CSmartPtr<T, Array>& SmartPtr)
{
	_Release();

	_Pointer = SmartPtr._Pointer;
	_RefCounter = SmartPtr._RefCounter;
	if(_RefCounter != null)
		++(*_RefCounter);

	return *this;
}

template <typename T, bool Array>
CSmartPtr<T, Array>& CSmartPtr<T, Array>::operator=(T* Pointer)
{
	_Release();

	_Pointer = Pointer;
	_RefCounter = new_object(int)(1);

	return *this;
}

template <typename T, bool Array>
bool CSmartPtr<T, Array>::operator==(const CSmartPtr<T, Array>& SmartPtr) const
{
	return _Pointer == SmartPtr._Pointer;
}

template <typename T, bool Array>
bool CSmartPtr<T, Array>::operator!=(const CSmartPtr<T, Array>& SmartPtr) const
{
	return _Pointer != SmartPtr._Pointer;
}

template <typename T, bool Array>
T& CSmartPtr<T, Array>::operator*()
{
	return *_Pointer;
}

template <typename T, bool Array>
T* CSmartPtr<T, Array>::operator->()
{
	return _Pointer;
}

template <typename T, bool Array>
const T& CSmartPtr<T, Array>::operator*() const
{
	return *_Pointer;
}

template <typename T, bool Array>
const T* CSmartPtr<T, Array>::operator->() const
{
	return _Pointer;
}

template <typename T, bool Array>
void CSmartPtr<T, Array>::_Release()
{
	if(_RefCounter != null)
	{
		(*_RefCounter)--;
		if(*_RefCounter <= 0)
		{
			if(Array)
			{
				delete_array(_RefCounter);
				if(_Pointer != null)
					delete_array(_Pointer);
			}
			else
			{
				delete_object(_RefCounter);
				if(_Pointer != null)
					delete_object(_Pointer);
			}
		}
	}
}

}//namespace core
}//namespace o
